using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Rediscovery.BusinessHybrid;
using Rediscovery.BusinessHybrid.Sweep;
using Rediscovery.BusinessHybrid.ImportExport;
using System.IO;
using Rediscovery.SystemFramework;
using System.Runtime.Remoting.Messaging;

namespace RediscoveryForInternet
{
    public class RFIFunctions
    {
        private static string wordType = "";
        private string connection;
        private DataDirectoryInfo dataDirectoryInfo;
        private static string tableName="";
        public static string GetLinkField(string FieldValue, string HotSubjects, string FieldName, string ConnectionString, bool GlobalSearch, bool GeneralSubjects, string TableName, string ArtistLink)
        {
            tableName = TableName;
            return GetLinkField(FieldValue, HotSubjects, FieldName, ConnectionString, GlobalSearch, GeneralSubjects, ArtistLink);
        }



        public static string GetLinkField(string FieldValue, string HotSubjects, string FieldName, string ConnectionString, bool GlobalSearch, bool GeneralSubjects, string ArtistLink)
        {
            try
            {
                //return FieldValue;
                string returnString = FieldValue.Replace("<", "").Replace(">", "");
                string newString = "";
                wordType = "";
                if (returnString.IndexOf(FormattedMemoTools.RepeatDelimiter) > -1 || returnString.IndexOf(FormattedMemoTools.SubfieldDelimiter) > -1)
                {
                    try
                    {
                        for (int i = 0; i < FormattedMemoTools.GetNumRows(returnString); ++i)
                        {
                            string oneRow = FormattedMemoTools.GetEntireRow(returnString, i);
                            for (int j = 0; j < FormattedMemoTools.GetNumColumns(oneRow); ++j)
                            {
                                string oneField = FormattedMemoTools.GetSubFieldValue(oneRow, j);
                                if (CanMakeALink(oneField))
                                {

                                    newString = newString + " <a href="+oneField + " >" + oneField + "</a> ";
                                }
                                else
                                {
                                    if (IsHotSubject(HotSubjects, FieldName))
                                    {
                                        int nbrOfSubjects = RedString.GetOccurs(oneField, FormattedMemoTools.StackedRepeatDelimiter) + 1;
                                        for (int k = 0; k < nbrOfSubjects; k++)
                                        {
                                            string subjectReference = FormattedMemoTools.GetStackedItem(oneField, k, FormattedMemoTools.StackedRepeatDelimiter);
                                            string tblfileDesc = getTblDesc(HotSubjects, subjectReference, FieldName, ConnectionString);

                                            string generalSubjectReference = subjectReference;

                                            if (GeneralSubjects)
                                            {
                                                generalSubjectReference = GetFirstSubjectSegment(generalSubjectReference);
                                                newString = newString + "  <a href = \"ArchivesBrowseSubjects.aspx?*=" + generalSubjectReference.Replace(" ", "&&").Trim() + "*" + "\" ToolTip=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                            }
                                            else
                                            {
                                                if (GlobalSearch)
                                                    newString = newString + "  <a href = \"GlobalSearch.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40\" ToolTip=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                                else
                                                    if (tableName != string.Empty)
                                                        newString = newString + "  <a href = \"SearchResults.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40__" + tableName + "\" ToolTip=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                                    else
                                                        newString = newString + "  <a href = \"SearchResults.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40\" ToolTip=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                            }
                                            if (ArtistLink != string.Empty)
                                                if (FieldName.ToLower() == "artist" || FieldName.ToLower() == "author")
                                                    newString = newString + "<a href = \"ShowArtist.aspx?" + subjectReference.Replace(" ", "&&") + "\" target=\"_blank\"> " + ArtistLink + "</a>";

                                        }
                                    }

                                    else
                                        return returnString;
                                }

                            }

                        }
                        returnString = newString;
                    }
                    catch (Exception ex)
                    {
                        return returnString;
                    }



                }
                else
                {
                    if (CanMakeALink(returnString))
                    {

                                    newString = newString + " <a href="+returnString + " >" + returnString + "</a> ";
                    }
                    else
                    {
                        if (IsHotSubject(HotSubjects, FieldName))
                        {
                            returnString = "";
                            int nbrOfSubjects = RedString.GetOccurs(FieldValue, FormattedMemoTools.StackedRepeatDelimiter) + 1;
                            for (int k = 0; k < nbrOfSubjects; k++)
                            {
                                string subjectReference = FormattedMemoTools.GetStackedItem(FieldValue, k, FormattedMemoTools.StackedRepeatDelimiter);
                                string tblfileDesc = getTblDesc(HotSubjects, subjectReference, FieldName, ConnectionString);
                                string generalSubjectReference = subjectReference;

                                if (GeneralSubjects)
                                {
                                    generalSubjectReference = GetFirstSubjectSegment(generalSubjectReference);
                                    newString = newString + "  <a href = \"ArchivesBrowseSubjects.aspx?*=" + generalSubjectReference.Replace(" ", "&&").Trim() + "*" + "\" ToolTip=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                }
                                else
                                {
                                    if (GlobalSearch)
                                        returnString = returnString + "  <a href = \"GlobalSearch.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40\" Title=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                    else
                                        if (tableName != string.Empty)
                                            returnString = returnString + "  <a href = \"SearchResults.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40__" + tableName + "\" Title=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                        else
                                            returnString = returnString + "  <a href = \"SearchResults.aspx?" + wordType + "%40%40" + subjectReference.Replace(" ", "&&") + "%40%40\" Title=\"" + tblfileDesc + "\" target=\"_blank\" >" + subjectReference + "</a> ";
                                }
                                if (ArtistLink != string.Empty)
                                    if (FieldName.ToLower() == "artist" || FieldName.ToLower() == "author")
                                        returnString = returnString + "<a href = \"ShowArtist.aspx?" + subjectReference.Replace(" ", "&&") + "\" target=\"_blank\"> " + ArtistLink + "</a>";

                            }
                        }
                    }

                }
                return returnString;
            }
            catch
            {
                return FieldValue;
            }
        }
        private static string GetFirstSubjectSegment(string subject)
        {
            int pos = subject.IndexOf("--");
            if (pos == -1)
                return subject;
            return subject.Substring(0, pos);
        }

        private static string getTblDesc(string HotSubjects, string FieldValue, string FieldName, string ConnectionString)
        {
            //Field1=sub_topic:Annotations
            int pos = HotSubjects.ToLower().IndexOf(FieldName.ToLower().Trim());

            string tblkey = HotSubjects.Substring(pos + FieldName.Trim().Length + 1);
            if (tblkey.IndexOf(";") > -1)
                tblkey = tblkey.Substring(0, tblkey.IndexOf(";"));

            if (tblkey.IndexOf("::") > -1)
            {
                wordType = tblkey.Substring(tblkey.IndexOf("::") + 2);
                tblkey = tblkey.Substring(0, tblkey.IndexOf("::"));
            }
            LookupData tblfile = new LookupData();
            tblfile.ConnectionString = ConnectionString;
            tblfile.LoadByLookupKeyValue(tblkey, FieldValue);
            if (tblfile.DefaultView.Count > 0)
                if (tblfile.Tbl_mem.Trim() == string.Empty)
                    return "@@" + FieldValue + "@@";
                else
                    return tblfile.Tbl_mem;
            else
                return "@@" + FieldValue + "@@";
        }

        private static bool IsHotSubject(string HotSubjects, string FieldName)
        {
            //Field1=sub_topic:Annotations
            if (HotSubjects.ToLower().IndexOf(FieldName.ToLower().Trim() + ":") > -1)
                return true;
            return false;

        }

        private static bool CanMakeALink(string command)
        {
            if (command == null)
                return false;

            if (command.ToUpper().IndexOf("HTTP") == 0 ||
                command.ToUpper().IndexOf("FTP") == 0 ||
                command.ToUpper().IndexOf("MAILTO") == 0)
                return true;

            return false;
        }

        public static byte[] GetDocumentLink(string TableName, int RecordID, int SequenceNumber, string Directory, ref string extensionType)
        {

            if (Directory == string.Empty)
                return null;
            DatabaseMetadata databaseMetadata = new DatabaseMetadata();
            databaseMetadata.ConnectionString = ConnectionStringTools.DbfConnectionString;
            DataDirectoryInfo dataDirectoryInfo = databaseMetadata.GetDataDirectoryByName(Directory);
            return GetDocumentLink(TableName, RecordID, SequenceNumber, dataDirectoryInfo, ref extensionType);
        }
        public static byte[] GetDocumentLink(string TableName, int RecordID, int SequenceNumber, DataDirectoryInfo dataDirectoryInfo, ref string extensionType)
        {

            if (!SystemOptions.Initialized)
                SystemOptions.Initialize(ConnectionStringTools.DbfConnectionString);
            if (!Customization.Initialized)
                Customization.Initialize();
            BinaryWriter bw;
            byte[] mediaBuffer;
            MediaData mediaData = new MediaData();
            mediaData.ConnectionString = dataDirectoryInfo.ConnectionStrings[TableName];
            mediaData.Where.Record_id.Value = RecordID;
            mediaData.Where.Record_id.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.Mediasequence.Value = SequenceNumber;
            mediaData.Where.Mediasequence.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.Mediasequence.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;
            mediaData.Where.RelatedTable.Value = TableName;
            mediaData.Where.RelatedTable.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.RelatedTable.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;
            mediaData.Where.Properties.Value = "% __n";
            mediaData.Where.Properties.Operator = MyGeneration.dOOdads.WhereParameter.Operand.NotLike;
            mediaData.Where.Properties.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;

            mediaData.Query.Load();
            if (mediaData.DefaultView.Count > 0)
            {
                string originalFileName = Path.GetFileName(mediaData.DefaultView[0][MediaData.ColumnNames.OriginalPath].ToString());
                string newFilePart = Path.GetFileNameWithoutExtension(originalFileName) + DateTime.Now.Millisecond.ToString();
                string newExtension = Path.GetExtension(originalFileName);
                extensionType = newExtension.Replace(".", "");
                string tempDirectory = Environment.GetFolderPath(Environment.SpecialFolder.InternetCache);
                string tempFile = Path.Combine(tempDirectory, newFilePart + newExtension);
                if (File.Exists(tempFile))
                    File.Delete(tempFile);
                //FileStream fs = new FileStream(tempFile, System.IO.FileMode.Create);
                try
                {
                    mediaBuffer = (byte[])mediaData.DefaultView[0][MediaData.ColumnNames.Media];
                }
                catch
                {
                    mediaBuffer = null;
                }
                return mediaBuffer;
                //try
                //{
                //    bw = new BinaryWriter(fs);
                //    bw.Write(mediaBuffer);
                //    fs.Close();

                //}
                //catch (Exception)
                //{
                //}
                //return bw;
                //                return tempFile;
            }
            return null;
        }
        public string HTMLMarkup(string TableName, int RecordID, int SequenceNumber, string directory, string FullTextFileName, string[] Words, string footer, int LinesPerPage)
        {

            //string loginNameString = getDecodedString(LoginName);
            //string loginPassword = getDecodedString(EncryptedPassword);

            try
            {
                SystemOptions.Initialize(ConnectionStringTools.DbfConnectionString);
            }
            catch (Exception ex)
            {
                return "Database connection failed - " + ConnectionStringTools.DbfConnectionString;
            }
            //if (!RedSecurity.Login(loginNameString, loginPassword))
            //{
            //    Unimpersonate();
            //    return "Login name and/or password validation failed.";
            //}
            connection = ConnectionStringTools.DbfConnectionString;
            if (!SystemOptions.Initialized)
                SystemOptions.Initialize(connection);
            if (!Customization.Initialized)
                Customization.Initialize();
            DatabaseMetadata dbm = new DatabaseMetadata();
            dbm.ConnectionString = ConnectionStringTools.DbfConnectionString;
            dataDirectoryInfo = dbm.GetDataDirectoryByName(directory);
            MediaData mediaData = new MediaData();
            mediaData.ConnectionString = dataDirectoryInfo.ConnectionStrings[TableName];
            mediaData.LoadFromSql("select record_id, mediasequence, relatedtable, LEN(textVersion) 'lenfld' from media where record_id = " + RecordID.ToString() + " and mediasequence = " +
                SequenceNumber.ToString() + " and relatedtable = '" + TableName + "'", null, CommandType.Text);
            int fieldLength = -1;
            if (mediaData.DefaultView.Count > 0)
            {
                fieldLength = System.Convert.ToInt32(mediaData.DefaultView[0]["lenfld"]);
                //if (fieldLength > 200000)

                //    return "Use Document Link";
            }
            mediaData.ConnectionString = dataDirectoryInfo.ConnectionStrings[TableName];

            mediaData = new MediaData();
            mediaData.ConnectionString = dataDirectoryInfo.ConnectionStrings[TableName];
            mediaData.Query.AddResultColumn(MediaData.ColumnNames.Record_id);
            mediaData.Query.AddResultColumn(MediaData.ColumnNames.Mediasequence);
            mediaData.Query.AddResultColumn(MediaData.ColumnNames.RelatedTable);
            mediaData.Query.AddResultColumn(MediaData.ColumnNames.TextVersion);

            mediaData.Where.Record_id.Value = RecordID;
            mediaData.Where.Record_id.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.Mediasequence.Value = SequenceNumber;
            mediaData.Where.Mediasequence.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.Mediasequence.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;
            mediaData.Where.RelatedTable.Value = TableName;
            mediaData.Where.RelatedTable.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
            mediaData.Where.RelatedTable.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;
            mediaData.Where.Properties.Value = "% __n";
            mediaData.Where.Properties.Operator = MyGeneration.dOOdads.WhereParameter.Operand.NotLike;
            mediaData.Where.Properties.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;

            mediaData.Query.Load();
            if (mediaData.DefaultView.Count > 0)
            {
                //ImportText it = new ImportText();
                Markup it = new Markup(LinesPerPage);
                //                return "startup markup";
                it.BeginMarkup(mediaData.DefaultView[0][MediaData.ColumnNames.TextVersion].ToString(), Words, footer, FullTextFileName, new AsyncCallback(OnMarkupCompletion), null);
                //                return "started markup";

                //                it.ActuallyMarkup(mediaData.DefaultView[0][MediaData.ColumnNames.TextVersion].ToString(), Words, footer, FullTextFileName);
                //</div>    </body>    </html> 

            }
            return "";






        }

        protected void OnMarkupCompletion(IAsyncResult asyncResult)
        {
            AsyncResult resultObj = (AsyncResult)asyncResult;
        }

    }
}
