using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using Rediscovery.BusinessHybrid.Entities;
using Rediscovery.SystemFramework;
using Rediscovery.BusinessHybrid;
using ICSharpCode.SharpZipLib.Zip;
using ICSharpCode.SharpZipLib.Core;
using Rediscovery.BusinessHybrid.Imaging;
using Rediscovery.BusinessHybrid.Supplementals;
using Rediscovery.BusinessHybrid.Archives;
using Rediscovery.BusinessHybrid;

namespace WebSiteUpdate
{
    public partial class UpdateSQLData : System.Web.UI.Page
    {
        private DataTable zipFiles;
        private DataTable dataBases;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SystemOptions.Initialize();
                Customization.Initialize();

                ImpersonationClass ic = new ImpersonationClass();
                if (Session["Login"] == null)
                {
                    Session["Login"] = ic.LoginName;
                    Session["Domain"] = ic.Domain;
                    Session["PassWord"] = ic.PassWord;
                }
                ic.Impersonate(Session["Domain"].ToString(), Session["Login"].ToString(), Session["PassWord"].ToString());
                string thisDirectory = System.AppDomain.CurrentDomain.BaseDirectory;
                string uploadsDirectory = Path.Combine(thisDirectory, "uploads");
                if (!Directory.Exists(uploadsDirectory))
                    Directory.CreateDirectory(uploadsDirectory);
                string[] zipFilesFound = Directory.GetFiles(uploadsDirectory, "*.zip");
                if (zipFilesFound.Length == 0)
                {
                    this.LabelMessage.Text = "No uploaded update zip files found";
                    this.LinkButton1.Enabled = false;
                    this.ASPxGridView1.Visible = false;
                }
                else
                {
                    this.LabelMessage.Text = "Please select an update zip file";
                    zipFiles = new DataTable();
                    zipFiles.Columns.Add("ZipFile");
                    foreach (string zipFileFound in zipFilesFound)
                    {
                        DataRow newRow = zipFiles.DefaultView.Table.NewRow();
                        newRow["ZipFile"] = Path.GetFileName(zipFileFound);
                        zipFiles.DefaultView.Table.Rows.Add(newRow);
                    }
                    this.ASPxGridView1.DataSource = zipFiles.DefaultView;
                    this.ASPxGridView1.DataBind();
                    this.ASPxGridView1.FocusedRowIndex = 0;
                    this.ASPxGridView1.Visible = true;
                    this.LinkButton1.Enabled = true;
                }
                LoadDataBases();

            }
        }

        protected void LoadDataBases()
        {
            dataBases = new DataTable();
            dataBases.Columns.Clear();
            dataBases.Columns.Add("DataBase");
            string DatabasesList = Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "databases.config");
            if (File.Exists(DatabasesList))
            {
                string[] dataBasesInList = File.ReadAllLines(DatabasesList);
                foreach (string databaseName in dataBasesInList)
                {
                    DataRow newRow = dataBases.DefaultView.Table.NewRow();
                    newRow["DataBase"] = databaseName;
                    dataBases.DefaultView.Table.Rows.Add(databaseName);
                }
            }
            else
            {
                DatabaseMetadataEntities dbmetadata = new DatabaseMetadataEntities();
                dbmetadata.ConnectionString = ConnectionStringTools.DbfConnectionString;

                dbmetadata.MasterEntity.LoadFromSql("execute sp_databases", null, CommandType.Text);
                foreach (DataRow database in dbmetadata.MasterEntity.DefaultView.Table.Rows)
                {
                    string databaseName = database["database_name"].ToString().Trim();
                    if (databaseName.ToLower().StartsWith("rediscovery"))
                    {
                        DataRow newRow = dataBases.DefaultView.Table.NewRow();
                        newRow["DataBase"] = databaseName;
                        dataBases.DefaultView.Table.Rows.Add(databaseName);
                    }
                }
            }
            this.ASPxGridView2.DataSource = dataBases.DefaultView;
            ASPxGridView2.DataBind();
            this.ASPxGridView2.FocusedRowIndex = 0;
            this.ASPxGridView2.Visible = true;
        }
        protected void LinkButton1_Click(object sender, EventArgs e)
        {
            this.LabelMessage.Text = "";
            string fileName = Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory, "update.config");
            if (System.IO.File.Exists(fileName))
            {
                string encPassword = File.ReadAllText(fileName);
                string clearPassword = ImpersonationClass.getDecodedString(encPassword);
                if (clearPassword != ASPxTextBox1.Text)
                {
                    this.LabelMessage.Text = "Incorrect password entered.";
                    return;
                }
            }
            else
            {
                this.LabelMessage.Text = "Unable to access Web Site Update password.";
                return;
            }
            ImpersonationClass ic = new ImpersonationClass();
            if (Session["Login"] == null)
            {
                Session["Login"] = ic.LoginName;
                Session["Domain"] = ic.Domain;
                Session["PassWord"] = ic.PassWord;
            }
            ic.Impersonate(Session["Domain"].ToString(), Session["Login"].ToString(), Session["PassWord"].ToString());
            string thisDirectory = System.AppDomain.CurrentDomain.BaseDirectory;
            string uploadsDirectory = Path.Combine(thisDirectory, "uploads");
            string [] fieldToGet = new string [1];
            fieldToGet[0] = "ZipFile";
            string selectedZipFile = this.ASPxGridView1.GetRowValues(this.ASPxGridView1.FocusedRowIndex, fieldToGet).ToString();
            LabelMessage.Text = "Apply zipfile: " + selectedZipFile;//Path.Combine(uploadsDirectory, selectedZipFile);
            string [] fieldToGet2 = new string [1];
            fieldToGet2[0] = "DataBase";
            string databaseToUpdate = this.ASPxGridView2.GetRowValues(this.ASPxGridView2.FocusedRowIndex,fieldToGet2).ToString();
            //updateWebSiteData(selectedZipFile, databaseToUpdate);
            WebDirectoryUpdate wdu = new WebDirectoryUpdate();
            wdu.UpdateWebData(selectedZipFile, databaseToUpdate);
            this.LabelMessage.Text = "Web Site Update is complete.  "+selectedZipFile +" applied to " + databaseToUpdate + ".";

        }

        //protected void ProcessFile(object sender, ScanEventArgs e)
        //{
        //    //Console.WriteLine(e.Name);
        //    //this.NewSubTask("Unzipping " + e.Name + "...");
        //}

        //protected void ProcessDirectory(object sender, DirectoryEventArgs e)
        //{
        //    //if (!e.HasMatchingFiles)
        //    //{
        //    //    //Console.WriteLine(e.Name);
        //    //}
        //}

        //private void updateWebSiteData(string zipFileName, string dataBaseName)
        //{
        //    //WebUpdateWorkDirectory
        //    FastZipEvents events = null;

        //    events = new FastZipEvents();
        //    events.ProcessDirectory = new ProcessDirectoryHandler(ProcessDirectory);
        //    events.ProcessFile = new ProcessFileHandler(ProcessFile);
        //    FastZip sz = new FastZip(events);
        //    sz.CreateEmptyDirectories = true;
        //    string thisDirectory = System.AppDomain.CurrentDomain.BaseDirectory;
        //    string uploadsDirectory = Path.Combine(thisDirectory, "uploads");
        //    string workDirectory = Path.Combine(thisDirectory, "WebUpdateWorkDirectory");
        //    string dataDirectory = Path.Combine(workDirectory,"ServerBackups");
        //    sz.ExtractZip(Path.Combine(uploadsDirectory, zipFileName),workDirectory , "");
        //    string destDirectory = SystemOptions.Instance.FullImageInternalPath;
        //    string sourceDirectory = Path.Combine(workDirectory, "fullimages");
        //    FileIO.CopyFolder(sourceDirectory, destDirectory, true);
        //    destDirectory = SystemOptions.Instance.ThumbnailImagePath;
        //    sourceDirectory = Path.Combine(workDirectory, "thumbnails");
        //    FileIO.CopyFolder(sourceDirectory, destDirectory, true);
        //    ImagingData images = new ImagingData();
        //    images.ConnectionString = ConnectionStringTools.DbfConnectionString;
        //    DataTable imageTable = new DataTable();
        //    imageTable.ReadXml(Path.Combine(dataDirectory,"images.xml"));
        //    foreach (DataRow oneImage in imageTable.DefaultView.Table.Rows)
        //    {
        //        images.Where.Image_key.Value = oneImage[ImagingData.ColumnNames.Image_key].ToString();
        //        images.Where.Image_key.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
        //        images.Where.Image_seq.Value = (int)oneImage[ImagingData.ColumnNames.Image_seq];
        //        images.Where.Image_seq.Operator = MyGeneration.dOOdads.WhereParameter.Operand.Equal;
        //        images.Where.Image_seq.Conjuction = MyGeneration.dOOdads.WhereParameter.Conj.And;
        //        images.Query.Load();
        //        if (images.DefaultView.Count == 0)
        //        {
        //            DataRow newImage = images.DefaultView.Table.NewRow();
        //            foreach (DataColumn oneColumn in imageTable.DefaultView.Table.Columns)
        //            {
        //                if (oneColumn.ColumnName.ToLower() != "image_id")
        //                {
        //                    newImage[oneColumn.ColumnName] = oneImage[oneColumn.ColumnName];
        //                }
        //            }
        //            images.DefaultView.Table.Rows.Add(newImage);
        //        }
        //        else
        //        {
        //            foreach (DataColumn oneColumn in imageTable.DefaultView.Table.Columns)
        //            {
        //                if (oneColumn.ColumnName.ToLower() != "image_id")
        //                {
        //                    images.DefaultView[0][oneColumn.ColumnName] = oneImage[oneColumn.ColumnName];
        //                }
        //            }

        //        }
        //        images.Save();

        //    }
        //    string[] files = Directory.GetFiles(dataDirectory, "objects.xml");
        //    if (files.Length > 0)
        //    {
        //        LoadMainData("objects", dataDirectory, dataBaseName, "Collections");
        //    }
        //    else
        //    {
        //        files = Directory.GetFiles(dataDirectory, "exhibt.xml");
        //        if (files.Length > 0)
        //        {
        //            LoadMainData("exhibt", dataDirectory, dataBaseName, "Collections");
        //        }
        //        else
        //        {
        //            files = Directory.GetFiles(dataDirectory, "group.xml");
        //            if (files.Length > 0)
        //            {
        //                LoadMainData("group", dataDirectory, dataBaseName, "Archives");
        //            }
        //            else
        //            {
        //                files = Directory.GetFiles(dataDirectory, "series.xml");
        //                if (files.Length > 0)
        //                {
        //                    LoadMainData("series", dataDirectory, dataBaseName, "Archives");
        //                }
        //                else
        //                {
        //                    files = Directory.GetFiles(dataDirectory, "fileunit.xml");
        //                    if (files.Length > 0)
        //                    {
        //                        LoadMainData("fileunit", dataDirectory, dataBaseName, "Archives");
        //                    }
        //                    else
        //                    {
        //                        files = Directory.GetFiles(dataDirectory, "biblio.xml");
        //                        if (files.Length > 0)
        //                        {
        //                            LoadMainData("biblio", dataDirectory, dataBaseName, "Archives");
        //                        }

        //                    }

        //                }

        //            }

        //        }
        //    }
        //    FileIO.DeleteDirectory(Path.Combine(workDirectory,"ServerBackups"));
        //    FileIO.DeleteDirectory(Path.Combine(workDirectory,"FullImages"));
        //    FileIO.DeleteDirectory(Path.Combine(workDirectory,"ThumbNails"));
        //    File.Move(Path.Combine(uploadsDirectory, zipFileName), Path.Combine(uploadsDirectory, zipFileName + ".uploaded"));
        //}
        //private void LoadMainData(string mainTable, string dataDirectory, string dataBaseName, string DirType)
        //{
        //    DataTable MainData = new DataTable();
        //    MainData.ReadXml(Path.Combine(dataDirectory,mainTable+".xml"));
        //    //DatabaseMetadata dbm = new DatabaseMetadata();
        //    //dbm.ConnectionString = ConnectionStringTools.DbfConnectionString;
        //    //dbm.Where.
        //    EntitiesInfo entiesInfo = EntitiesInfoFactory.CreateEntitiesInfo(mainTable);

        //    if (DirType.ToLower() == "collections")
        //        SystemMetadata.LoadCollectionDirectories();
        //    else
        //        SystemMetadata.LoadArchivesDirectories();
        //    DataDirectoryInfo dataDirectoryInfo =  SystemMetadata.Instance[dataBaseName.Substring(dataBaseName.IndexOf("_")+1)];
        //    SupplementalDataBase supplData = SupplementalDataFactory.Create(mainTable, dataDirectoryInfo);
        //    supplData.ConnectionString = dataDirectoryInfo.ConnectionString;
        //    supplData.Query.Top = 1;
        //    supplData.Query.Load();
        //    supplData.Query.Top = -1;
        //    DataTable supplTable = new DataTable();
        //    string multrelName = Path.Combine(dataDirectory,supplData.DefaultView.Table.TableName+".xml");
        //    bool hasMultrel = false;
        //    if (File.Exists(multrelName))
        //    {
        //        hasMultrel = true;
        //        supplTable.ReadXml(multrelName);
        //    }
        //    entiesInfo.ConnectionString = dataDirectoryInfo.ConnectionStrings[mainTable];
        //    foreach (DataRow oneRow in MainData.DefaultView.Table.Rows)
        //    {
        //        string keyValue = oneRow[entiesInfo.ReadablePrimaryKeyColumn].ToString();
        //        switch (mainTable.ToLower())
        //        {
        //            case "objects":
        //                entiesInfo.LoadByReadablePrimaryKey(keyValue);
        //                break;
        //            case "group":
        //                ((GroupData)entiesInfo.MasterEntity).LoadByReadablePrimaryKey(oneRow[GroupData.ColumnNames.Group_nbr].ToString());
        //                break;
        //            case "series":
        //                ((SeriesData)entiesInfo.MasterEntity).LoadByReadablePrimaryKey(oneRow[SeriesData.ColumnNames.Group_nbr].ToString(), oneRow[SeriesData.ColumnNames.Series_nbr].ToString());
        //                break;
        //            case "fileunit":
        //                ((FileUnitData)entiesInfo.MasterEntity).LoadByReadablePrimaryKey(oneRow[FileUnitData.ColumnNames.Group_nbr].ToString(),
        //                    oneRow[FileUnitData.ColumnNames.Series_nbr].ToString(),oneRow[FileUnitData.ColumnNames.Fileunit_nbr].ToString());
        //                break;
        //            case "biblio":
        //                ((BiblioData)entiesInfo.MasterEntity).LoadByReadablePrimaryKey(oneRow[BiblioData.ColumnNames.Group_nbr].ToString(),
        //                    oneRow[BiblioData.ColumnNames.Series_nbr].ToString(), oneRow[BiblioData.ColumnNames.Fileunit_nbr].ToString(),
        //                    oneRow[BiblioData.ColumnNames.Biblio_nbr].ToString());
        //                break;
        //            default:
        //                break;
        //     }
        //        int newIdNumber = -1;
        //        if (entiesInfo.MasterEntity.DefaultView.Count == 0)
        //        {
        //            DataRow newRow = entiesInfo.MasterEntity.DefaultView.Table.NewRow();
        //            foreach (DataColumn oneColumn in entiesInfo.MasterEntity.DefaultView.Table.Columns)
        //            {
        //                if (oneColumn.ColumnName.ToLower() != entiesInfo.PrimaryKeyColumn.ToLower())
        //                {
        //                    newRow[oneColumn.ColumnName] = oneRow[oneColumn.ColumnName];
        //                }
        //            }
        //            entiesInfo.MasterEntity.DefaultView.Table.Rows.Add(newRow);
        //            entiesInfo.MasterEntity.Save();
        //            newIdNumber = (int)newRow[entiesInfo.PrimaryKeyColumn]; 
        //        }
        //        else
        //        {
        //            newIdNumber = (int)entiesInfo.MasterEntity.DefaultView[0][entiesInfo.PrimaryKeyColumn];
        //            foreach (DataColumn oneColumn in entiesInfo.MasterEntity.DefaultView.Table.Columns)
        //            {
        //                if (oneColumn.ColumnName.ToLower() != entiesInfo.PrimaryKeyColumn.ToLower())
        //                {
        //                    entiesInfo.MasterEntity.DefaultView[0][oneColumn.ColumnName] = oneRow[oneColumn.ColumnName];
        //                }
        //            }
        //            entiesInfo.MasterEntity.Save();
        //            if (hasMultrel)
        //            {
        //                supplData.LoadById(newIdNumber);
        //                if (supplData.DefaultView.Count > 0)
        //                {
        //                    supplData.DeleteAll();
        //                    supplData.Save();
        //                }
        //            }

        //        }
        //        if (hasMultrel)
        //        {
        //            DataRow[] relSupplRows = supplTable.Select("record_id = " + oneRow["Record_id"].ToString());
        //            foreach (DataRow oneSuppl in relSupplRows)
        //            {
        //                DataRow newSuppl = supplData.DefaultView.Table.NewRow();
        //                foreach (DataColumn oneColumn in supplData.DefaultView.Table.Columns)
        //                {
        //                    if (oneColumn.ColumnName.ToLower() == "record_id")
        //                    {
        //                        newSuppl["record_id"] = newIdNumber;
        //                    }
        //                    else
        //                    {
        //                        newSuppl[oneColumn.ColumnName] = oneSuppl[oneColumn.ColumnName];
        //                    }


        //                }
        //                supplData.DefaultView.Table.Rows.Add(newSuppl);
        //            }
        //            supplData.Save();
        //        }
        //    }
        //}
        //private void ExhibtType()
        //{
        //}
        //private void GroupType()
        //{
        //}
        //private void SeriesType()
        //{
        //}
        //private void FileUnitType()
        //{
        //}
        //private void BiblioType()
        //{
        //}
    }
}
